"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.npmPackageWorkspacesAction = void 0;

var _util = require("util");

var _toolLib = require("@kettil/tool-lib");

var _glob = require("glob");

var _packageLoad = require("./packageLoad");

const globPromise = (0, _util.promisify)(_glob.glob);

const npmPackageWorkspacesAction = async argv => {
  const workspaces = await (0, _packageLoad.npmPackageLoadAction)(argv, {
    key: 'workspaces'
  });

  if (!(0, _toolLib.isArray)(workspaces)) {
    return [];
  }

  const paths = await Promise.all(workspaces.filter(workspace => typeof workspace === 'string').map(workspace => globPromise(workspace, {
    cwd: argv.root,
    absolute: true
  })));
  return paths.flat();
};

exports.npmPackageWorkspacesAction = npmPackageWorkspacesAction;